3 # Copyright (c) 2005 Junio C Hamano
6 -include ..
/config.mak.autogen
9 #GIT_TEST_OPTS = --verbose --debug
10 SHELL_PATH ?
= $(SHELL
)
11 TEST_SHELL_PATH ?
= $(SHELL_PATH
)
12 PERL_PATH ?
= /usr
/bin
/perl
16 DEFAULT_TEST_TARGET ?
= test
17 TEST_LINT ?
= test-lint
19 ifdef TEST_OUTPUT_DIRECTORY
20 TEST_RESULTS_DIRECTORY
= $(TEST_OUTPUT_DIRECTORY
)/test-results
21 CHAINLINTTMP
= $(TEST_OUTPUT_DIRECTORY
)/chainlinttmp
23 TEST_RESULTS_DIRECTORY
= test-results
24 CHAINLINTTMP
= chainlinttmp
28 SHELL_PATH_SQ
= $(subst ','\'',$(SHELL_PATH))
29 TEST_SHELL_PATH_SQ = $(subst ','\'',$(TEST_SHELL_PATH
))
30 PERL_PATH_SQ
= $(subst ','\'',$(PERL_PATH))
31 TEST_RESULTS_DIRECTORY_SQ = $(subst ','\'',$(TEST_RESULTS_DIRECTORY
))
32 CHAINLINTTMP_SQ
= $(subst ','\'',$(CHAINLINTTMP))
34 T = $(sort $(wildcard t[0-9][0-9][0-9][0-9]-*.sh))
35 TGITWEB = $(sort $(wildcard t95[0-9][0-9]-*.sh))
36 THELPERS = $(sort $(filter-out $(T),$(wildcard *.sh)))
37 TPERF = $(sort $(wildcard perf/p[0-9][0-9][0-9][0-9]-*.sh))
38 CHAINLINTTESTS = $(sort $(patsubst chainlint/%.test,%,$(wildcard chainlint/*.test)))
39 CHAINLINT = sed -f chainlint.sed
41 all: $(DEFAULT_TEST_TARGET)
43 test: pre-clean check-chainlint $(TEST_LINT)
44 $(MAKE) aggregate-results-and-cleanup
47 @failed=$$(cd '$(TEST_RESULTS_DIRECTORY_SQ
)' && \
48 grep -l '^failed
[1-9]' *.counts | \
49 sed -n 's
/\.counts
$$/.sh
/p
') && \
50 test -z "$$failed" || $(MAKE) $$failed
52 prove: pre-clean check-chainlint $(TEST_LINT)
53 @echo "*** prove ***"; $(PROVE) --exec '$(TEST_SHELL_PATH_SQ
)' $(GIT_PROVE_OPTS) $(T) :: $(GIT_TEST_OPTS)
54 $(MAKE) clean-except-prove-cache
57 @echo "*** $@ ***"; '$(TEST_SHELL_PATH_SQ
)' $@ $(GIT_TEST_OPTS)
60 $(RM) -r '$(TEST_RESULTS_DIRECTORY_SQ
)'
62 clean-except-prove-cache: clean-chainlint
63 $(RM) -r 'trash directory
'.* '$(TEST_RESULTS_DIRECTORY_SQ
)'
66 clean: clean-except-prove-cache
70 $(RM) -r '$(CHAINLINTTMP_SQ
)'
73 @mkdir -p '$(CHAINLINTTMP_SQ
)' && \
75 for i in $(CHAINLINTTESTS); do \
76 $(CHAINLINT) <chainlint/$$i.test | \
77 sed -e '/^
# LINT: /d' >'$(CHAINLINTTMP_SQ)'/$$i.actual && \
78 diff
-u chainlint
/$$i.expect
'$(CHAINLINTTMP_SQ)'/$$i.actual || err
=1; \
81 test-lint
: test-lint-duplicates test-lint-executable test-lint-shell-syntax \
85 @dups
=`echo $(T) $(TPERF) | tr ' ' '\n' | sed 's/-.*//' | sort | uniq -d` && \
86 test -z
"$$dups" ||
{ \
87 echo
>&2 "duplicate test numbers:" $$dups; exit
1; }
90 @bad
=`for i in $(T) $(TPERF); do test -x "$$i" || echo $$i; done` && \
91 test -z
"$$bad" ||
{ \
92 echo
>&2 "non-executable tests:" $$bad; exit
1; }
94 test-lint-shell-syntax
:
95 @
'$(PERL_PATH_SQ)' check-non-portable-shell.pl
$(T
) $(THELPERS
) $(TPERF
)
98 @
# We do *not* pass a glob to ls-files but use grep instead, to catch
99 @
# non-ASCII characters (which are quoted within double-quotes)
100 @bad
="$$(git -c core.quotepath=true ls-files 2>/dev/null | \
101 grep '["*:<>?
\\|
]')"; \
102 test -z "$$bad" || { \
103 echo >&2 "non-portable file name(s): $$bad"; exit 1; }
105 aggregate-results-and-cleanup: $(T)
106 $(MAKE) aggregate-results
110 for f in '$(TEST_RESULTS_DIRECTORY_SQ
)'/t*-*.counts; do \
112 done | '$(SHELL_PATH_SQ
)' ./aggregate-results.sh
118 $(MAKE) GIT_TEST_OPTS="$(GIT_TEST_OPTS) --valgrind"
123 .PHONY: pre-clean $(T) aggregate-results clean valgrind perf check-chainlint clean-chainlint